JUCE: AudioProcessorGraph Class Reference

JUCE

Classes | Public Types | Public Member Functions | List of all members
AudioProcessorGraph Class Reference
juce_audio_processors » processors

A type of AudioProcessor which plays back a graph of other AudioProcessors. More...

`#include <juce_AudioProcessorGraph.h>`

Inheritance diagram for AudioProcessorGraph:

## Classes
class | AudioGraphIOProcessor
| A special type of AudioProcessor that can live inside an AudioProcessorGraph in order to use the audio that comes into and out of the graph itself. More...
struct | Connection
| Represents a connection between two channels of two nodes in an AudioProcessorGraph. More...
class | Node
| Represents one of the nodes, or processors, in an AudioProcessorGraph. More...
struct | NodeAndChannel
| Represents an input or output channel of a node in an AudioProcessorGraph. More...
struct | NodeID
| Each node in the graph has a UID of this type. More...

## Public Types
enum | { midiChannelIndex = 0x1000 }
| A special index that represents the midi channel of a node. More...
Public Types inherited from AudioProcessor
enum | ProcessingPrecision { singlePrecision , doublePrecision }
enum class | Realtime { no , yes }
enum | WrapperType { wrapperType_Undefined = 0 , wrapperType_VST , wrapperType_VST3 , wrapperType_AudioUnit , wrapperType_AudioUnitv3 , wrapperType_AAX , wrapperType_Standalone , wrapperType_Unity , wrapperType_LV2 }
| Flags to indicate the type of plugin context in which a processor is being used. More...
using | ChangeDetails = AudioProcessorListener::ChangeDetails

## Public Member Functions
| AudioProcessorGraph ()
| Creates an empty graph. More...
| ~AudioProcessorGraph () override
| Destructor. More...
void | clear ()
| Deletes all nodes and connections from this graph. More...
const ReferenceCountedArray< Node > & | getNodes () const noexcept
| Returns the array of nodes in the graph. More...
int | getNumNodes () const noexcept
| Returns the number of nodes in the graph. More...
Node::Ptr | getNode (int index) const noexcept
| Returns a pointer to one of the nodes in the graph. More...
Node * | getNodeForId (NodeID) const
| Searches the graph for a node with the given ID number and returns it. More...
Node::Ptr | addNode (std::unique_ptr< AudioProcessor > newProcessor, NodeID nodeId={})
| Adds a node to the graph. More...
Node::Ptr | removeNode (NodeID)
| Deletes a node within the graph which has the specified ID. More...
Node::Ptr | removeNode (Node *)
| Deletes a node within the graph. More...
std::vector< Connection > | getConnections () const
| Returns the list of connections in the graph. More...
bool | isConnected (const Connection &) const noexcept
| Returns true if the given connection exists. More...
bool | isConnected (NodeID possibleSourceNodeID, NodeID possibleDestNodeID) const noexcept
| Returns true if there is a direct connection between any of the channels of two specified nodes. More...
bool | isAnInputTo (Node &source, Node &destination) const noexcept
| Does a recursive check to see if there's a direct or indirect series of connections between these two nodes. More...
bool | canConnect (const Connection &) const
| Returns true if it would be legal to connect the specified points. More...
bool | addConnection (const Connection &)
| Attempts to connect two specified channels of two nodes. More...
bool | removeConnection (const Connection &)
| Deletes the given connection. More...
bool | disconnectNode (NodeID)
| Removes all connections from the specified node. More...
bool | isConnectionLegal (const Connection &) const
| Returns true if the given connection's channel numbers map on to valid channels at each end. More...
bool | removeIllegalConnections ()
| Performs a sanity checks of all the connections. More...
const String | getName () const override
| Returns the name of this processor. More...
void | prepareToPlay (double, int) override
| Called before playback starts, to let the processor prepare itself. More...
void | releaseResources () override
| Called after playback has stopped, to let the object free up any resources it no longer needs. More...
void | processBlock (AudioBuffer< float > &, MidiBuffer &) override
| Renders the next block. More...
void | processBlock (AudioBuffer< double > &, MidiBuffer &) override
| Renders the next block. More...
bool | supportsDoublePrecisionProcessing () const override
| Returns true if the Audio processor supports double precision floating point processing. More...
void | reset () override
| A plugin can override this to be told when it should reset any playing voices. More...
void | setNonRealtime (bool) noexcept override
| Called by the host to tell this processor whether it's being used in a non-realtime capacity for offline rendering or bouncing. More...
double | getTailLengthSeconds () const override
| Returns the length of the processor's tail, in seconds. More...
bool | acceptsMidi () const override
| Returns true if the processor wants MIDI messages. More...
bool | producesMidi () const override
| Returns true if the processor produces MIDI messages. More...
bool | hasEditor () const override
| Your processor subclass must override this and return true if it can create an editor component. More...
AudioProcessorEditor * | createEditor () override
| Creates the processor's GUI. More...
int | getNumPrograms () override
| Returns the number of preset programs the processor supports. More...
int | getCurrentProgram () override
| Returns the number of the currently active program. More...
void | setCurrentProgram (int) override
| Called by the host to change the current program. More...
const String | getProgramName (int) override
| Must return the name of a given program. More...
void | changeProgramName (int, const String &) override
| Called by the host to rename a program. More...
void | getStateInformation (juce::MemoryBlock &) override
| The host will call this method when it wants to save the processor's internal state. More...
void | setStateInformation (const void *data, int sizeInBytes) override
| This must restore the processor's state from a block of data previously created using getStateInformation(). More...
Public Member Functions inherited from AudioProcessor
virtual | ~AudioProcessor ()
| Destructor. More...
virtual const String | getName () const =0
| Returns the name of this processor. More...
virtual StringArray | getAlternateDisplayNames () const
| Returns a list of alternative names to use for this processor. More...
virtual void | prepareToPlay (double sampleRate, int maximumExpectedSamplesPerBlock)=0
| Called before playback starts, to let the processor prepare itself. More...
virtual void | releaseResources ()=0
| Called after playback has stopped, to let the object free up any resources it no longer needs. More...
virtual void | memoryWarningReceived ()
| Called by the host to indicate that you should reduce your memory footprint. More...
virtual void | processBlock (AudioBuffer< float > &buffer, MidiBuffer &midiMessages)=0
| Renders the next block. More...
virtual void | processBlock (AudioBuffer< double > &buffer, MidiBuffer &midiMessages)
| Renders the next block. More...
virtual void | processBlockBypassed (AudioBuffer< float > &buffer, MidiBuffer &midiMessages)
| Renders the next block when the processor is being bypassed. More...
virtual void | processBlockBypassed (AudioBuffer< double > &buffer, MidiBuffer &midiMessages)
| Renders the next block when the processor is being bypassed. More...
int | getBusCount (bool isInput) const noexcept
| Returns the number of buses on the input or output side. More...
Bus * | getBus (bool isInput, int busIndex) noexcept
| Returns the audio bus with a given index and direction. More...
const Bus * | getBus (bool isInput, int busIndex) const noexcept
| Returns the audio bus with a given index and direction. More...
virtual bool | canAddBus (bool isInput) const
| Callback to query if a bus can currently be added. More...
virtual bool | canRemoveBus (bool isInput) const
| Callback to query if the last bus can currently be removed. More...
bool | addBus (bool isInput)
| Dynamically request an additional bus. More...
bool | removeBus (bool isInput)
| Dynamically remove the latest added bus. More...
bool | setBusesLayout (const BusesLayout &)
| Set the channel layouts of this audio processor. More...
bool | setBusesLayoutWithoutEnabling (const BusesLayout &)
| Set the channel layouts of this audio processor without changing the enablement state of the buses. More...
BusesLayout | getBusesLayout () const
| Provides the current channel layouts of this audio processor. More...
AudioChannelSet | getChannelLayoutOfBus (bool isInput, int busIndex) const noexcept
| Provides the channel layout of the bus with a given index and direction. More...
bool | setChannelLayoutOfBus (bool isInput, int busIndex, const AudioChannelSet &layout)
| Set the channel layout of the bus with a given index and direction. More...
int | getChannelCountOfBus (bool isInput, int busIndex) const noexcept
| Provides the number of channels of the bus with a given index and direction. More...
bool | enableAllBuses ()
| Enables all buses. More...
bool | disableNonMainBuses ()
| Disables all non-main buses (aux and sidechains). More...
int | getChannelIndexInProcessBlockBuffer (bool isInput, int busIndex, int channelIndex) const noexcept
| Returns the position of a bus's channels within the processBlock buffer. More...
int | getOffsetInBusBufferForAbsoluteChannelIndex (bool isInput, int absoluteChannelIndex, int &busIndex) const noexcept
| Returns the offset in a bus's buffer from an absolute channel index. More...
template<typename FloatType >
AudioBuffer< FloatType > | getBusBuffer (AudioBuffer< FloatType > &processBlockBuffer, bool isInput, int busIndex) const
| Returns an AudioBuffer containing a set of channel pointers for a specific bus. More...
bool | checkBusesLayoutSupported (const BusesLayout &) const
| Returns true if the Audio processor is likely to support a given layout. More...
virtual bool | supportsDoublePrecisionProcessing () const
| Returns true if the Audio processor supports double precision floating point processing. More...
ProcessingPrecision | getProcessingPrecision () const noexcept
| Returns the precision-mode of the processor. More...
bool | isUsingDoublePrecision () const noexcept
| Returns true if the current precision is set to doublePrecision. More...
void | setProcessingPrecision (ProcessingPrecision newPrecision) noexcept
| Changes the processing precision of the receiver. More...
AudioPlayHead * | getPlayHead () const noexcept
| Returns the current AudioPlayHead object that should be used to find out the state and position of the playhead. More...
int | getTotalNumInputChannels () const noexcept
| Returns the total number of input channels. More...
int | getTotalNumOutputChannels () const noexcept
| Returns the total number of output channels. More...
int | getMainBusNumInputChannels () const noexcept
| Returns the number of input channels on the main bus. More...
int | getMainBusNumOutputChannels () const noexcept
| Returns the number of output channels on the main bus. More...
template<size_t numLayouts>
BusesLayout | getNextBestLayoutInLayoutList (const BusesLayout &layouts, const short(&channelLayoutList)[numLayouts][2])
| Returns the next best layout which is contained in a channel layout map. More...
double | getSampleRate () const noexcept
| Returns the current sample rate. More...
int | getBlockSize () const noexcept
| Returns the current typical block size that is being used. More...
int | getLatencySamples () const noexcept
| This returns the number of samples delay that the processor imposes on the audio passing through it. More...
void | setLatencySamples (int newLatency)
| Your processor subclass should call this to set the number of samples delay that it introduces. More...
virtual double | getTailLengthSeconds () const =0
| Returns the length of the processor's tail, in seconds. More...
virtual bool | acceptsMidi () const =0
| Returns true if the processor wants MIDI messages. More...
virtual bool | producesMidi () const =0
| Returns true if the processor produces MIDI messages. More...
virtual bool | supportsMPE () const
| Returns true if the processor supports MPE. More...
virtual bool | isMidiEffect () const
| Returns true if this is a MIDI effect plug-in and does no audio processing. More...
const CriticalSection & | getCallbackLock () const noexcept
| This returns a critical section that will automatically be locked while the host is calling the processBlock() method. More...
void | suspendProcessing (bool shouldBeSuspended)
| Enables and disables the processing callback. More...
bool | isSuspended () const noexcept
| Returns true if processing is currently suspended. More...
virtual void | reset ()
| A plugin can override this to be told when it should reset any playing voices. More...
virtual AudioProcessorParameter * | getBypassParameter () const
| Returns the parameter that controls the AudioProcessor's bypass state. More...
bool | isNonRealtime () const noexcept
| Returns true if the processor is being run in an offline mode for rendering. More...
Realtime | isRealtime () const noexcept
| Returns no if the processor is being run in an offline mode for rendering. More...
virtual void | setNonRealtime (bool isNonRealtime) noexcept
| Called by the host to tell this processor whether it's being used in a non-realtime capacity for offline rendering or bouncing. More...
virtual AudioProcessorEditor * | createEditor ()=0
| Creates the processor's GUI. More...
virtual bool | hasEditor () const =0
| Your processor subclass must override this and return true if it can create an editor component. More...
AudioProcessorEditor * | getActiveEditor () const noexcept
| Returns the active editor, if there is one. More...
AudioProcessorEditor * | createEditorIfNeeded ()
| Returns the active editor, or if there isn't one, it will create one. More...
void | updateHostDisplay (const ChangeDetails &details=ChangeDetails::getDefaultFlags())
| The processor can call this when something (apart from a parameter value) has changed. More...
void | addParameter (AudioProcessorParameter *)
| Adds a parameter to the AudioProcessor. More...
void | addParameterGroup (std::unique_ptr< AudioProcessorParameterGroup >)
| Adds a group of parameters to the AudioProcessor. More...
const AudioProcessorParameterGroup & | getParameterTree () const
| Returns the group of parameters managed by this AudioProcessor. More...
void | setParameterTree (AudioProcessorParameterGroup &&newTree)
| Sets the group of parameters managed by this AudioProcessor. More...
virtual void | refreshParameterList ()
| A processor should implement this method so that the host can ask it to rebuild its parameter tree. More...
const Array< AudioProcessorParameter * > & | getParameters () const
| Returns a flat list of the parameters in the current tree. More...
virtual int | getNumPrograms ()=0
| Returns the number of preset programs the processor supports. More...
virtual int | getCurrentProgram ()=0
| Returns the number of the currently active program. More...
virtual void | setCurrentProgram (int index)=0
| Called by the host to change the current program. More...
virtual const String | getProgramName (int index)=0
| Must return the name of a given program. More...
virtual void | changeProgramName (int index, const String &newName)=0
| Called by the host to rename a program. More...
virtual void | getStateInformation (juce::MemoryBlock &destData)=0
| The host will call this method when it wants to save the processor's internal state. More...
virtual void | getCurrentProgramStateInformation (juce::MemoryBlock &destData)
| The host will call this method if it wants to save the state of just the processor's current program. More...
virtual void | setStateInformation (const void *data, int sizeInBytes)=0
| This must restore the processor's state from a block of data previously created using getStateInformation(). More...
virtual void | setCurrentProgramStateInformation (const void *data, int sizeInBytes)
| The host will call this method if it wants to restore the state of just the processor's current program. More...
virtual void | numChannelsChanged ()
| This method is called when the total number of input or output channels is changed. More...
virtual void | numBusesChanged ()
| This method is called when the number of buses is changed. More...
virtual void | processorLayoutsChanged ()
| This method is called when the layout of the audio processor changes. More...
virtual void | addListener (AudioProcessorListener *newListener)
| Adds a listener that will be called when an aspect of this processor changes. More...
virtual void | removeListener (AudioProcessorListener *listenerToRemove)
| Removes a previously added listener. More...
virtual void | setPlayHead (AudioPlayHead *newPlayHead)
| Tells the processor to use this playhead object. More...
void | setPlayConfigDetails (int numIns, int numOuts, double sampleRate, int blockSize)
| This is called by the processor to specify its details before being played. More...
void | setRateAndBufferSizeDetails (double sampleRate, int blockSize) noexcept
| This is called by the processor to specify its details before being played. More...
virtual int32 | getAAXPluginIDForMainBusConfig (const AudioChannelSet &mainInputLayout, const AudioChannelSet &mainOutputLayout, bool idForAudioSuite) const
| AAX plug-ins need to report a unique "plug-in id" for every audio layout configuration that your AudioProcessor supports on the main bus. More...
virtual CurveData | getResponseCurve (CurveData::Type) const
void | editorBeingDeleted (AudioProcessorEditor *) noexcept
| Not for public use - this is called before deleting an editor component. More...
virtual void | updateTrackProperties (const TrackProperties &properties)
| Informs the AudioProcessor that track properties such as the track's name or colour has been changed. More...
Public Member Functions inherited from ChangeBroadcaster
| ChangeBroadcaster () noexcept
| Creates an ChangeBroadcaster. More...
virtual | ~ChangeBroadcaster ()
| Destructor. More...
void | addChangeListener (ChangeListener *listener)
| Registers a listener to receive change callbacks from this broadcaster. More...
void | removeChangeListener (ChangeListener *listener)
| Unregisters a listener from the list. More...
void | removeAllChangeListeners ()
| Removes all listeners from the list. More...
void | sendChangeMessage ()
| Causes an asynchronous change message to be sent to all the registered listeners. More...
void | sendSynchronousChangeMessage ()
| Sends a synchronous change message to all the registered listeners. More...
void | dispatchPendingMessages ()
| If a change message has been sent but not yet dispatched, this will call sendSynchronousChangeMessage() to make the callback immediately. More...

## Additional Inherited Members
Static Public Member Functions inherited from AudioProcessor
static bool | containsLayout (const BusesLayout &layouts, const std::initializer_list< const short[2]> &channelLayoutList)
| Returns true if the channel layout map contains a certain layout. More...
template<size_t numLayouts>
static bool | containsLayout (const BusesLayout &layouts, const short(&channelLayoutList)[numLayouts][2])
static int | getDefaultNumParameterSteps () noexcept
| Returns the default number of steps for a parameter. More...
static const char * | getWrapperTypeDescription (AudioProcessor::WrapperType) noexcept
| Returns a textual description of a WrapperType value. More...
static void | copyXmlToBinary (const XmlElement &xml, juce::MemoryBlock &destData)
| Helper function that just converts an xml element into a binary blob. More...
static std::unique_ptr< XmlElement > | getXmlFromBinary (const void *data, int sizeInBytes)
| Retrieves an XML element that was stored as binary with the copyXmlToBinary() method. More...
static void JUCE_CALLTYPE | setTypeOfNextNewPlugin (WrapperType)
Public Attributes inherited from AudioProcessor
const WrapperType | wrapperType
| When loaded by a plugin wrapper, this flag will be set to indicate the type of plugin within which the processor is running. More...
Protected Member Functions inherited from AudioProcessor
| AudioProcessor ()
| Constructor. More...
| AudioProcessor (const BusesProperties &ioLayouts)
| Constructor for multi-bus AudioProcessors. More...
| AudioProcessor (const std::initializer_list< const short[2]> &channelLayoutList)
| Constructor for AudioProcessors which use layout maps If your AudioProcessor uses layout maps then use this constructor. More...
virtual bool | isBusesLayoutSupported (const BusesLayout &) const
| Callback to query if the AudioProcessor supports a specific layout. More...
virtual bool | canApplyBusesLayout (const BusesLayout &layouts) const
| Callback to check if a certain bus layout can now be applied. More...
virtual bool | applyBusLayouts (const BusesLayout &layouts)
| This method will be called when a new bus layout needs to be applied. More...
virtual bool | canApplyBusCountChange (bool isInput, bool isAddingBuses, BusProperties &outNewBusProperties)
| Callback to query if adding/removing buses currently possible. More...
void | sendParamChangeMessageToListeners (int parameterIndex, float newValue)
Protected Attributes inherited from AudioProcessor
std::atomic< AudioPlayHead * > | playHead { nullptr }

## Detailed Description

A type of AudioProcessor which plays back a graph of other AudioProcessors.

Use one of these objects if you want to wire-up a set of AudioProcessors and play back the result.

Processors can be added to the graph as "nodes" using addNode(), and once added, you can connect any of their input or output channels to other nodes using addConnection().

To play back a graph through an audio device, you might want to use an AudioProcessorPlayer object.

## Member Enumeration Documentation

## ◆ anonymous enum

anonymous enum

A special index that represents the midi channel of a node.

This is used as a channel index value if you want to refer to the midi input or output instead of an audio channel.

Enumerator
midiChannelIndex |

## Constructor & Destructor Documentation

## ◆ AudioProcessorGraph()

AudioProcessorGraph::AudioProcessorGraph | ( |  | ) |

Creates an empty graph.

## ◆ ~AudioProcessorGraph()

AudioProcessorGraph::~AudioProcessorGraph | ( |  | ) |
| override

Destructor.

Any processor objects that have been added to the graph will also be deleted.

## Member Function Documentation

## ◆ clear()

void AudioProcessorGraph::clear | ( |  | ) |

Deletes all nodes and connections from this graph.

Any processor objects in the graph will be deleted.

## ◆ getNodes()

const ReferenceCountedArray< Node > & AudioProcessorGraph::getNodes | ( |  | ) | const
| noexcept

Returns the array of nodes in the graph.

## ◆ getNumNodes()

int AudioProcessorGraph::getNumNodes | ( |  | ) | const
| noexcept

Returns the number of nodes in the graph.

## ◆ getNode()

Node::Ptr AudioProcessorGraph::getNode | ( | int | index | ) | const
| noexcept

Returns a pointer to one of the nodes in the graph.

This will return nullptr if the index is out of range.

See also
  getNodeForId

References gl::index.

## ◆ getNodeForId()

Node * AudioProcessorGraph::getNodeForId | ( | NodeID |  | ) | const

Searches the graph for a node with the given ID number and returns it.

If no such node was found, this returns nullptr.

See also
  getNode

## ◆ addNode()

Node::Ptr AudioProcessorGraph::addNode | ( | std::unique_ptr< AudioProcessor > | newProcessor,
|  | NodeID | nodeId = `{}`
| ) |  |

Adds a node to the graph.

This creates a new node in the graph, for the specified processor. Once you have added a processor to the graph, the graph owns it and will delete it later when it is no longer needed.

The optional nodeId parameter lets you specify a unique ID to use for the node. If the value is already in use, this method will fail and return an empty node.

If this succeeds, it returns a pointer to the newly-created node.

## ◆ removeNode() [1/2]

Node::Ptr AudioProcessorGraph::removeNode | ( | NodeID |  | ) |

Deletes a node within the graph which has the specified ID.

This will also delete any connections that are attached to this node.

## ◆ removeNode() [2/2]

Node::Ptr AudioProcessorGraph::removeNode | ( | Node * |  | ) |

Deletes a node within the graph.

This will also delete any connections that are attached to this node.

## ◆ getConnections()

std::vector< Connection > AudioProcessorGraph::getConnections | ( |  | ) | const

Returns the list of connections in the graph.

## ◆ isConnected() [1/2]

bool AudioProcessorGraph::isConnected | ( | const Connection & |  | ) | const
| noexcept

Returns true if the given connection exists.

## ◆ isConnected() [2/2]

bool AudioProcessorGraph::isConnected | ( | NodeID | possibleSourceNodeID,
|  | NodeID | possibleDestNodeID
| ) |  | const
| noexcept

Returns true if there is a direct connection between any of the channels of two specified nodes.

## ◆ isAnInputTo()

bool AudioProcessorGraph::isAnInputTo | ( | Node & | source,
|  | Node & | destination
| ) |  | const
| noexcept

Does a recursive check to see if there's a direct or indirect series of connections between these two nodes.

## ◆ canConnect()

bool AudioProcessorGraph::canConnect | ( | const Connection & |  | ) | const

Returns true if it would be legal to connect the specified points.

## ◆ addConnection()

bool AudioProcessorGraph::addConnection | ( | const Connection & |  | ) |

Attempts to connect two specified channels of two nodes.

If this isn't allowed (e.g. because you're trying to connect a midi channel to an audio one or other such nonsense), then it'll return false.

## ◆ removeConnection()

bool AudioProcessorGraph::removeConnection | ( | const Connection & |  | ) |

Deletes the given connection.

## ◆ disconnectNode()

bool AudioProcessorGraph::disconnectNode | ( | NodeID |  | ) |

Removes all connections from the specified node.

## ◆ isConnectionLegal()

bool AudioProcessorGraph::isConnectionLegal | ( | const Connection & |  | ) | const

Returns true if the given connection's channel numbers map on to valid channels at each end.

Even if a connection is valid when created, its status could change if a node changes its channel config.

## ◆ removeIllegalConnections()

bool AudioProcessorGraph::removeIllegalConnections | ( |  | ) |

Performs a sanity checks of all the connections.

This might be useful if some of the processors are doing things like changing their channel counts, which could render some connections obsolete.

## ◆ getName()

const String AudioProcessorGraph::getName | ( |  | ) | const
| overridevirtual

Returns the name of this processor.

Implements AudioProcessor.

## ◆ prepareToPlay()

void AudioProcessorGraph::prepareToPlay | ( | double | sampleRate,
|  | int | maximumExpectedSamplesPerBlock
| ) |  |
| overridevirtual

Called before playback starts, to let the processor prepare itself.

The sample rate is the target sample rate, and will remain constant until playback stops.

You can call getTotalNumInputChannels and getTotalNumOutputChannels or query the busLayout member variable to find out the number of channels your processBlock callback must process.

The maximumExpectedSamplesPerBlock value is a strong hint about the maximum number of samples that will be provided in each block. You may want to use this value to resize internal buffers. You should program defensively in case a buggy host exceeds this value. The actual block sizes that the host uses may be different each time the callback happens: completely variable block sizes can be expected from some hosts.

See also
  busLayout, getTotalNumInputChannels, getTotalNumOutputChannels

Implements AudioProcessor.

## ◆ releaseResources()

void AudioProcessorGraph::releaseResources | ( |  | ) |
| overridevirtual

Called after playback has stopped, to let the object free up any resources it no longer needs.

Implements AudioProcessor.

## ◆ processBlock() [1/2]

void AudioProcessorGraph::processBlock | ( | AudioBuffer< float > & | buffer,
|  | MidiBuffer & | midiMessages
| ) |  |
| overridevirtual

Renders the next block.

When this method is called, the buffer contains a number of channels which is at least as great as the maximum number of input and output channels that this processor is using. It will be filled with the processor's input data and should be replaced with the processor's output.

So for example if your processor has a total of 2 input channels and 4 output channels, then the buffer will contain 4 channels, the first two being filled with the input data. Your processor should read these, do its processing, and replace the contents of all 4 channels with its output.

Or if your processor has a total of 5 inputs and 2 outputs, the buffer will have 5 channels, all filled with data, and your processor should overwrite the first 2 of these with its output. But be VERY careful not to write anything to the last 3 channels, as these might be mapped to memory that the host assumes is read-only!

If your plug-in has more than one input or output buses then the buffer passed to the processBlock methods will contain a bundle of all channels of each bus. Use getBusBuffer to obtain an audio buffer for a particular bus.

Note that if you have more outputs than inputs, then only those channels that correspond to an input channel are guaranteed to contain sensible data - e.g. in the case of 2 inputs and 4 outputs, the first two channels contain the input, but the last two channels may contain garbage, so you should be careful not to let this pass through without being overwritten or cleared.

Also note that the buffer may have more channels than are strictly necessary, but you should only read/write from the ones that your processor is supposed to be using.

The number of samples in these buffers is NOT guaranteed to be the same for every callback, and may be more or less than the estimated value given to prepareToPlay(). Your code must be able to cope with variable-sized blocks, or you're going to get clicks and crashes!

Also note that some hosts will occasionally decide to pass a buffer containing zero samples, so make sure that your algorithm can deal with that!

If the processor is receiving a MIDI input, then the midiMessages array will be filled with the MIDI messages for this block. Each message's timestamp will indicate the message's time, as a number of samples from the start of the block.

Any messages left in the MIDI buffer when this method has finished are assumed to be the processor's MIDI output. This means that your processor should be careful to clear any incoming messages from the array if it doesn't want them to be passed-on.

If you have implemented the getBypassParameter method, then you need to check the value of this parameter in this callback and bypass your processing if the parameter has a non-zero value.

Note that when calling this method as a host, the result may still be bypassed as the parameter that controls the bypass may be non-zero.

Be very careful about what you do in this callback - it's going to be called by the audio thread, so any kind of interaction with the UI is absolutely out of the question. If you change a parameter in here and need to tell your UI to update itself, the best way is probably to inherit from a ChangeBroadcaster, let the UI components register as listeners, and then call sendChangeMessage() inside the processBlock() method to send out an asynchronous message. You could also use the AsyncUpdater class in a similar way.

See also
  getBusBuffer

Implements AudioProcessor.

## ◆ processBlock() [2/2]

void AudioProcessorGraph::processBlock | ( | AudioBuffer< double > & | buffer,
|  | MidiBuffer & | midiMessages
| ) |  |
| overridevirtual

Renders the next block.

When this method is called, the buffer contains a number of channels which is at least as great as the maximum number of input and output channels that this processor is using. It will be filled with the processor's input data and should be replaced with the processor's output.

So for example if your processor has a combined total of 2 input channels and 4 output channels, then the buffer will contain 4 channels, the first two being filled with the input data. Your processor should read these, do its processing, and replace the contents of all 4 channels with its output.

Or if your processor has 5 inputs and 2 outputs, the buffer will have 5 channels, all filled with data, and your processor should overwrite the first 2 of these with its output. But be VERY careful not to write anything to the last 3 channels, as these might be mapped to memory that the host assumes is read-only!

If your plug-in has more than one input or output buses then the buffer passed to the processBlock methods will contain a bundle of all channels of each bus. Use getBusBuffer to obtain a audio buffer for a particular bus.

Note that if you have more outputs than inputs, then only those channels that correspond to an input channel are guaranteed to contain sensible data - e.g. in the case of 2 inputs and 4 outputs, the first two channels contain the input, but the last two channels may contain garbage, so you should be careful not to let this pass through without being overwritten or cleared.

Also note that the buffer may have more channels than are strictly necessary, but you should only read/write from the ones that your processor is supposed to be using.

If your plugin uses buses, then you should use getBusBuffer() or getChannelIndexInProcessBlockBuffer() to find out which of the input and output channels correspond to which of the buses.

The number of samples in these buffers is NOT guaranteed to be the same for every callback, and may be more or less than the estimated value given to prepareToPlay(). Your code must be able to cope with variable-sized blocks, or you're going to get clicks and crashes!

Also note that some hosts will occasionally decide to pass a buffer containing zero samples, so make sure that your algorithm can deal with that!

If the processor is receiving a MIDI input, then the midiMessages array will be filled with the MIDI messages for this block. Each message's timestamp will indicate the message's time, as a number of samples from the start of the block.

Any messages left in the MIDI buffer when this method has finished are assumed to be the processor's MIDI output. This means that your processor should be careful to clear any incoming messages from the array if it doesn't want them to be passed-on.

If you have implemented the getBypassParameter method, then you need to check the value of this parameter in this callback and bypass your processing if the parameter has a non-zero value.

Note that when calling this method as a host, the result may still be bypassed as the parameter that controls the bypass may be non-zero.

Be very careful about what you do in this callback - it's going to be called by the audio thread, so any kind of interaction with the UI is absolutely out of the question. If you change a parameter in here and need to tell your UI to update itself, the best way is probably to inherit from a ChangeBroadcaster, let the UI components register as listeners, and then call sendChangeMessage() inside the processBlock() method to send out an asynchronous message. You could also use the AsyncUpdater class in a similar way.

See also
  getBusBuffer

Reimplemented from AudioProcessor.

## ◆ supportsDoublePrecisionProcessing()

bool AudioProcessorGraph::supportsDoublePrecisionProcessing | ( |  | ) | const
| overridevirtual

Returns true if the Audio processor supports double precision floating point processing.

The default implementation will always return false. If you return true here then you must override the double precision versions of processBlock. Additionally, you must call getProcessingPrecision() in your prepareToPlay method to determine the precision with which you need to allocate your internal buffers.

See also
  getProcessingPrecision, setProcessingPrecision

Reimplemented from AudioProcessor.

## ◆ reset()

void AudioProcessorGraph::reset | ( |  | ) |
| overridevirtual

A plugin can override this to be told when it should reset any playing voices.

The default implementation does nothing, but a host may call this to tell the plugin that it should stop any tails or sounds that have been left running.

Reimplemented from AudioProcessor.

## ◆ setNonRealtime()

void AudioProcessorGraph::setNonRealtime | ( | bool | isNonRealtime | ) |
| overridevirtualnoexcept

Called by the host to tell this processor whether it's being used in a non-realtime capacity for offline rendering or bouncing.

Reimplemented from AudioProcessor.

## ◆ getTailLengthSeconds()

double AudioProcessorGraph::getTailLengthSeconds | ( |  | ) | const
| overridevirtual

Returns the length of the processor's tail, in seconds.

Implements AudioProcessor.

## ◆ acceptsMidi()

bool AudioProcessorGraph::acceptsMidi | ( |  | ) | const
| overridevirtual

Returns true if the processor wants MIDI messages.

Implements AudioProcessor.

## ◆ producesMidi()

bool AudioProcessorGraph::producesMidi | ( |  | ) | const
| overridevirtual

Returns true if the processor produces MIDI messages.

Implements AudioProcessor.

## ◆ hasEditor()

bool AudioProcessorGraph::hasEditor | ( |  | ) | const
| overridevirtual

Your processor subclass must override this and return true if it can create an editor component.

See also
  createEditor

Implements AudioProcessor.

## ◆ createEditor()

AudioProcessorEditor * AudioProcessorGraph::createEditor | ( |  | ) |
| overridevirtual

Creates the processor's GUI.

This can return nullptr if you want a GUI-less processor, in which case the host may create a generic UI that lets the user twiddle the parameters directly.

If you do want to pass back a component, the component should be created and set to the correct size before returning it. If you implement this method, you must also implement the hasEditor() method and make it return true.

Remember not to do anything silly like allowing your processor to keep a pointer to the component that gets created - it could be deleted later without any warning, which would make your pointer into a dangler. Use the getActiveEditor() method instead.

The correct way to handle the connection between an editor component and its processor is to use something like a ChangeBroadcaster so that the editor can register itself as a listener, and be told when a change occurs. This lets them safely unregister themselves when they are deleted.

Here are a few things to bear in mind when writing an editor:

- Initially there won't be an editor, until the user opens one, or they might not open one at all. Your processor mustn't rely on it being there.
- An editor object may be deleted and a replacement one created again at any time.
- It's safe to assume that an editor will be deleted before its processor.

See also
  hasEditor

Implements AudioProcessor.

## ◆ getNumPrograms()

int AudioProcessorGraph::getNumPrograms | ( |  | ) |
| overridevirtual

Returns the number of preset programs the processor supports.

The value returned must be valid as soon as this object is created, and must not change over its lifetime.

This value shouldn't be less than 1.

Implements AudioProcessor.

## ◆ getCurrentProgram()

int AudioProcessorGraph::getCurrentProgram | ( |  | ) |
| overridevirtual

Returns the number of the currently active program.

Implements AudioProcessor.

## ◆ setCurrentProgram()

void AudioProcessorGraph::setCurrentProgram | ( | int | index | ) |
| overridevirtual

Called by the host to change the current program.

Implements AudioProcessor.

## ◆ getProgramName()

const String AudioProcessorGraph::getProgramName | ( | int | index | ) |
| overridevirtual

Must return the name of a given program.

Implements AudioProcessor.

## ◆ changeProgramName()

void AudioProcessorGraph::changeProgramName | ( | int | index,
|  | const String & | newName
| ) |  |
| overridevirtual

Called by the host to rename a program.

Implements AudioProcessor.

## ◆ getStateInformation()

void AudioProcessorGraph::getStateInformation | ( | juce::MemoryBlock & | destData | ) |
| overridevirtual

The host will call this method when it wants to save the processor's internal state.

This must copy any info about the processor's state into the block of memory provided, so that the host can store this and later restore it using setStateInformation().

Note that there's also a getCurrentProgramStateInformation() method, which only stores the current program, not the state of the entire processor.

See also the helper function copyXmlToBinary() for storing settings as XML.

See also
  getCurrentProgramStateInformation

Implements AudioProcessor.

## ◆ setStateInformation()

void AudioProcessorGraph::setStateInformation | ( | const void * | data,
|  | int | sizeInBytes
| ) |  |
| overridevirtual

This must restore the processor's state from a block of data previously created using getStateInformation().

Note that there's also a setCurrentProgramStateInformation() method, which tries to restore just the current program, not the state of the entire processor.

See also the helper function getXmlFromBinary() for loading settings as XML.

See also
  setCurrentProgramStateInformation

Implements AudioProcessor.

The documentation for this class was generated from the following file:

- juce_AudioProcessorGraph.h